////////////////////////////////////
//  Jazz enemy scripts
//   by shawn jones
////////////////////////////////////

string explode = <explo+7.pcx>;
string candy_1 = <candy1.mdl>;
sound deth_sound = <deth.wav>;
var bullet_speed[3];
string bullet_mdl = <blaster_shot.mdl>;

function explode_jazz ()
{
  my.frame = 1;
  ent_playsound (my,deth_sound,100);
  while (my.frame < 8) {
  my.frame += 1.5*time;
  wait(1);
  }
    my.event = null;
    remove my;
} 

function myfight_event()
{
  if (((EVENT_TYPE == EVENT_SCAN) && (indicator == _EXPLODE))
  || ((EVENT_TYPE == EVENT_SHOOT) && (indicator == _GUNFIRE)))
  {
    my._SIGNAL = 1; // by shooting, player also gives away his position
    if (my._ARMOR <= 0) { my._HEALTH -= damage; }
    else { my._ARMOR -= damage; }
  }
  if ((EVENT_TYPE == EVENT_DETECT) && (YOU == player))
  {
    my._SIGNAL = 1;
  }
}

function mystate_wait() 
{
  while (1)
  {
    if (my._HEALTH <= 0) { mystate_die(); return; }
//    if (my._HEALTH < 30) { mystate_escape(); return; }

    // Scanne den Player
    temp.PAN = 180;
    temp.TILT = 180;
    temp.Z = 1000;
    indicator = _WATCH;
    SCAN_ENTITY(my.x,temp);
    if (my._SIGNAL == 1) { mystate_attack(); return; }

    sleep(0.5);
  }
}

function mystate_attack() 
{
  my._ANIMDIST = 0;
  while (1)
  {
    if (my._HEALTH <= 0) { mystate_die(); return; }
//    if (my._HEALTH < 30) { mystate_escape(); return; }

    // zum Player hinwenden
    temp.X = player.X - my.X;
    temp.Y = player.Y - my.Y;
    temp.Z = player.Z - my.Z;
    vec_to_angle(my_angle,temp);
    force = 7; // set rotation speed
    actor_turn(); // rotate towards my_angle

    ent_CYCLE("attack", my._ANIMDIST);
    my._ANIMDIST += 5 * TIME;
    if (my._ANIMDIST > 100)
    {
      my._ANIMDIST -= 100;
      // fire at player at end of animation cycle
      shot_speed.X = 80;
      shot_speed.Y = 0;
      shot_speed.Z = 0;
      my_angle.PAN = my.PAN; // TILT is already set from vec_to_angle
      vec_rotate(shot_speed,my_angle);
      // now shot_speed points ahead, towards the player
      damage = 10;
      fire_mode = 2.25; // orange fireball, with smoke
      indicator = _gunfire;
      ent_CREATE("blaster_shot.mdl",my.x,bullet_shot);
    }
    wait(1);
  }
}

function mystate_escape()
{
  while (1)
  {
    if (my._HEALTH <= 0) { mystate_die(); return; }
    // turn away from player
    temp.X = my.X - player.X;
    temp.Y = my.Y - player.Y;
    temp.Z = my.Z - player.Z;
    vec_to_angle(my_angle,temp);
    force = 4;
    actor_turn();
    // walk away
    actor_move();
    wait(1);
  }
}

function mystate_die() 
{
//  my._ANIMDIST = 0; // reset entities' animation time to zero
//  while (my._ANIMDIST < 100)
//  {
//    ent_FRAME("death",my._ANIMDIST); // set the frame from the percentage
//    my._ANIMDIST += 5.0 * TIME; // calculate next percentage for death in ~1.25 seconds
//    wait(1);
//  }
  temp.x = my.x;
  temp.y = my.y;
  temp.z = my.z;
  ent_create (explode,temp,explode_jazz);
  ent_create (candy_1,temp,candy);
  my.enable_scan = OFF; // become insensible
  my.enable_shoot = OFF;
  my.event = NULL; // and don't react anymore
  remove my;
}




action jazz_bot 
{
  my._WALKFRAMES = 1;
  my._ENTFORCE = 1;
  my._ARMOR = 50;
  my._HEALTH = 100;
  my._SIGNAL = 0; // player not yet detected

  my.enable_scan = ON; // sensible of explosions
  my.enable_shoot = ON; // sensible of gunshots
  my.enable_detect = ON; // sensible of the player
  my.event = myfight_event; // handle hits & detection

  mystate_wait(); // First state: watch for the player
}







function remove_bullet()
{
     wait (1);
     if (you == player) {player._health -= 10;}
     ent_remove (me);
}



function move_bullet()
{
     wait (1);
     my.enable_entity = on;
     my.enable_block = on;
     my.event = remove_bullet;
     my.passable = on;
     my.visible = on;
     my.pan = you.pan;
     bullet_speed.x = 100;
     bullet_speed.y = 0;
     bullet_speed.z = 0;
     bullet_speed *= time;
     while (my != null)
     {
          if (you == null) {return;}
          if (vec_dist (my.x, you.x) < 100) // don't collide with the turret
          {
               my.passable = on;
          }
          else
          {
               my.passable = off;
          }
          ent_move (bullet_speed, nullvector);
          wait (1);
     }
} 



function destroy_turret()
{
     wait (1);
     if (you == player) {return;} // can't be destroyed by running into it
     snd_play (explo_wham, 70, 0);
     ent_remove (me);
} 



action turret
{
     if (my.skill1 == 0) {my.skill1 = 1000;} // set the range with skill1, default = 1000 quants
     if (my.skill2 == 0) {my.skill2 = 180;} // default viewing angle in front of the turret = 180
     my.enable_impact = on;
     my.event = destroy_turret;
     while (player == null) {wait (1);}
     while (my != null && player != null)
     {
          my.skill10 = abs(ang(player.pan) - ang(my.pan));
          if (vec_dist (my.x, player.x) < my.skill1)
          {
               if ((my.skill10 > 180 - my.skill2 / 2) && (my.skill10 < 180 + my.skill2 / 2))
               {
                    vec_set (temp.x, player.x);
                    vec_sub (temp.x, my.x);
                    vec_to_angle (my.pan, temp);
                    ent_create (bullet_mdl, my.pos, move_bullet);
               }
          }
          waitt (8); // fires 2 bullets a second
     }
} 







